LeetCode162. 寻找峰值

峰值元素是指其值严格大于左右相邻值的元素。

给你一个整数数组 nums,找到峰值元素并返回其索引。数组可能包含多个峰值,在这种情况下,返回 任何一个峰值 所在位置即可。

你可以假设 nums-1 = numsn = -∞ 。

你必须实现时间复杂度为 O(log n) 的算法来解决此问题。

示例 1:

输入:nums = 1,2,3,1

输出:2

解释:3 是峰值元素,你的函数应该返回其索引 2。

示例 2:

输入:nums = 1,2,1,3,5,6,4

输出:1 或 5

解释:你的函数可以返回索引 1,其峰值元素为 2;

或者返回索引 5, 其峰值元素为 6。

提示:

1 <= nums.length <= 1000

-2^31 <= numsi <= 2^31 - 1

对于所有有效的 i 都有 numsi != numsi + 1


解题思路:由于题目要求时间复杂度为O(logn),所以第一时间想到二分法

题目中说明了两个边界为无穷小,这个条件非常重要

当我们使用二分法,进行第一次二分时,如果是峰值元素,则可以直接返回所有号

如果numsmid-1>numsmid那么在左半端必有峰值元素,右半端同理

这是因为numsmid-1>numsmid,同时左边界为无穷小。此时在nums0~numsmid中必有峰值元素

就和现实中爬山一样,在numsmid端向左爬,是上山,但最终会下到山底,所以必然会有一个山峰

代码如下所示

java 复制代码
class Solution {
    
    public int findPeakElement(int[] nums) {
        int n=nums.length;
        //两个端点情况
        if(n==1||nums[0]>nums[1]) return 0;
        if(nums[n-1]>nums[n-2]) return n-1;
        //因为两侧都是谷底,所以在nums数组中比nums[mid]大的一侧的一侧必有山峰
        int l=0,r=nums.length,mid=(l+r)/2;
        while(r>l){
            if(nums[mid]>nums[mid+1]&&nums[mid]>nums[mid-1]){
                return mid;
            }
            if(nums[mid]<nums[mid+1]){
                l=mid;
                mid=(l+r)/2;
                continue;
            }
            if(nums[mid]<nums[mid-1]){
                r=mid;
                mid=(l+r)/2;
                continue;
            }
        } 
        return mid;
    }

}
相关推荐
CC数分19 分钟前
统计学基础|先把问题问对:数据分析的六大类型
大数据·人工智能·算法
地平线开发者1 小时前
CLIP 的训练机制:从对比学习到图文对齐
深度学习·算法·自动驾驶
PaperAccept1 小时前
【研知有术论文发表】材料科学一区期刊,影响因子30+的纳米科技SCI,审稿严格但有效率
大数据·数据结构·科技·量子计算
hetao17338371 小时前
2026-11-02 hetao1733837 的刷题记录
c++·算法
Geektec1 小时前
IMU 选型完全指南:从硬件参数到算法融合的系统工程视角
算法·imu·陀螺仪·加速度计·元器件选型
CQU_JIAKE2 小时前
11.2【A】
算法
Tairitsu_H2 小时前
[C++高阶数据结构·图论下] 最短路径:为什么“挑最小的”一定正确?
数据结构·c++·图论
Godspeed Zhao2 小时前
从零开始学AI21——决策树
算法·决策树·机器学习
开开心心就好2 小时前
网页图片批量下载工具,输入链接就保存
服务器·算法·leetcode·支持向量机·pdf·ocr·1024程序员节
Tairitsu_H3 小时前
[C++高阶数据结构·图论上] 最小生成树:为什么“选边”和“选点”是两条路?
数据结构·c++·图论·最小生成树